namespace org.accordproject.calendar;
using org.accordproject.time;
using org.accordproject.geo;
using AccordProject.Concerto;
[AccordProject.Concerto.Type(Namespace = "org.accordproject.calendar", Version = "0.2.0", Name = "CalendarComponent")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class CalendarComponent : Asset {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.calendar@0.2.0.CalendarComponent";
   [AccordProject.Concerto.Identifier()]
   public string uid { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.calendar", Version = "0.2.0", Name = "UniqueComponent")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class UniqueComponent : CalendarComponent {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.calendar@0.2.0.UniqueComponent";
   public string[] attendee { get; set; }
   public string[] comment { get; set; }
   public System.DateTime? dtstamp { get; set; }
   public string organizer { get; set; }
   public string[] requestStatuses { get; set; }
   public string url { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.calendar", Version = "0.2.0", Name = "RecurringComponent")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public abstract class RecurringComponent : UniqueComponent {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.calendar@0.2.0.RecurringComponent";
   public string[] attachements { get; set; }
   public string[] categories { get; set; }
   public string classType { get; set; }
   public string[] contacts { get; set; }
   public System.DateTime? created { get; set; }
   public string description { get; set; }
   public System.DateTime? lastModified { get; set; }
   public int? priority { get; set; }
   public string[] related { get; set; }
   public int? sequence { get; set; }
   public string summary { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.calendar", Version = "0.2.0", Name = "VAlarm")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class VAlarm : CalendarComponent {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.calendar@0.2.0.VAlarm";
   public string alarmAction { get; set; }
   public string attachment { get; set; }
   public string[] attendees { get; set; }
   public string description { get; set; }
   public Duration? duration { get; set; }
   public int? repeat { get; set; }
   public string summary { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.calendar", Version = "0.2.0", Name = "VEvent")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class VEvent : RecurringComponent {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.calendar@0.2.0.VEvent";
   public System.DateTime? dtend { get; set; }
   public Duration? duration { get; set; }
   public System.DateTime? end { get; set; }
   public bool? isAllDay { get; set; }
   public GeoCoordinates? geo { get; set; }
   public string location { get; set; }
   public string[] resources { get; set; }
   public string transparency { get; set; }
   public bool? isActive { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.calendar", Version = "0.2.0", Name = "VFreebusy")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class VFreebusy : UniqueComponent {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.calendar@0.2.0.VFreebusy";
   public System.DateTime? dtstart { get; set; }
   public System.DateTime? dtend { get; set; }
   public System.DateTime? start { get; set; }
   public System.DateTime? end { get; set; }
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.calendar", Version = "0.2.0", Name = "VJournal")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class VJournal : RecurringComponent {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.calendar@0.2.0.VJournal";
}
[AccordProject.Concerto.Type(Namespace = "org.accordproject.calendar", Version = "0.2.0", Name = "VTodo")]
[System.Text.Json.Serialization.JsonConverter(typeof(AccordProject.Concerto.ConcertoConverterFactorySystem))]
public class VTodo : RecurringComponent {
   [System.Text.Json.Serialization.JsonPropertyName("$class")]
   public override string _class { get; } = "org.accordproject.calendar@0.2.0.VTodo";
   public System.DateTime? completed { get; set; }
   public System.DateTime? due { get; set; }
   public Duration? duration { get; set; }
   public GeoCoordinates? geo { get; set; }
   public string location { get; set; }
   public int? percentComplete { get; set; }
   public string[] resources { get; set; }
   public string todo { get; set; }
}
